#! /bin/bash
#   pbuilder-user-mode-linux -- personal Debian package builder
#   Copyright (C) 2003-2007 Junichi Uekawa
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

set -e

while ! test -d ./debian -o "$(pwd)" = "/" ; do
    cd ..;
done

if test ! -d ./debian; then
    echo "E: Cannot find ./debian dir" >&2 
    exit 1
fi;
export PBCURRENTCOMMANDLINEOPERATION="pdebuild"

. /usr/lib/pbuilder/pbuilder-loadconfig
. /usr/lib/pbuilder/pdebuild-uml-checkparams

PKG_SOURCENAME=$(dpkg-parsechangelog|sed -n 's/^Source: //p')
PKG_VERSION=$(dpkg-parsechangelog|sed -n 's/^Version: \(.*:\|\)//p')
ARCHITECTURE=$(dpkg-architecture -qDEB_HOST_ARCH)


if [ "${USE_PDEBUILD_INTERNAL}" = 'yes' ]; then
    if [ ! readlink -f .. ]; then
	echo "E: Cannot find .. dir from PWD=$(pwd)" >&2 
	exit 1
    fi
    pbuilder-user-mode-linux execute "$@" --bindmounts $(readlink -f ..) /usr/lib/pbuilder/pdebuild-internal ${PWD} --debbuildopts "" --debbuildopts "${DEBBUILDOPTS}"
else
    if ! dpkg-checkbuilddeps -B; then
	echo "W: Unmet build-dependency in source" >&2 
    fi
    CMD="dpkg-buildpackage -S -us -uc -r${BUILDSOURCEROOTCMD} $DEBBUILDOPTS"
    echo "I: Running $CMD" >&2
    echo "$CMD" | /bin/bash
    pbuilder-user-mode-linux build "$@" --buildresult "${UML_BUILDRESULT}" ../"${PKG_SOURCENAME}_${PKG_VERSION}".dsc
fi

# do signing with optional key specifier
if [ "${AUTO_DEBSIGN}" = "yes" ]; then
    unset DEBSIGN_PARAM || true
    if [ -n "${DEBSIGN_KEYID}" ]; then
	DEBSIGN_PARAM[1]="-k${DEBSIGN_KEYID}"
    fi
    DEBSIGN_PARAM[2]="${UML_BUILDRESULT}/${PKG_SOURCENAME}_${PKG_VERSION}_${ARCHITECTURE}.changes"
    debsign "${DEBSIGN_PARAM[@]}"
fi
